package doxygen_csharp;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;

import org.xml.sax.SAXException;

import com.change_vision.jude.api.inf.exception.InvalidEditingException;
import com.change_vision.jude.api.inf.exception.ProjectNotFoundException;
import com.change_vision.jude.api.inf.model.IClass;
import com.change_vision.jude.api.inf.model.IElement;
import com.change_vision.jude.api.inf.model.IPackage;

public class CompoundDefCSharp extends CompoundDef {
	
	public static final String KIND_STRUCT = "struct";
	
	public void convertToJudeModel(IElement parent, File[] files) throws InvalidEditingException,
			ClassNotFoundException, ProjectNotFoundException, IOException, SAXException {
		if (compounddef.get(this.getCompounddefId()) != null) {
			return;
		}
		if (KIND_STRUCT.equals(this.getCompounddefKind())) {			
			IClass iclass = this.convertClass(parent, files, false);
			iclass.addStereotype("struct");
		} else {
			super.convertToJudeModel(parent, files);
		}
	}
	
	protected void dealWithGlobalElements(IPackage pkg, File[] files)
	throws ProjectNotFoundException, ClassNotFoundException,
	InvalidEditingException, IOException, SAXException {
		for (Iterator iterator = this.getSections().iterator(); iterator.hasNext();) {
			Section next = (Section) iterator.next();
			next.convertToJudeModelExceptEnum(pkg, files);
		}
	}
}