import java.io.IOException;

import com.change_vision.jude.api.inf.editor.BasicModelEditor;
import com.change_vision.jude.api.inf.editor.ModelEditorFactory;
import com.change_vision.jude.api.inf.editor.TransactionManager;
import com.change_vision.jude.api.inf.exception.InvalidEditingException;
import com.change_vision.jude.api.inf.exception.LicenseNotFoundException;
import com.change_vision.jude.api.inf.exception.ProjectLockedException;
import com.change_vision.jude.api.inf.exception.ProjectNotFoundException;
import com.change_vision.jude.api.inf.model.IClass;
import com.change_vision.jude.api.inf.model.IModel;
import com.change_vision.jude.api.inf.model.IPackage;
import com.change_vision.jude.api.inf.project.ProjectAccessor;
import com.change_vision.jude.api.inf.project.ProjectAccessorFactory;

/**
 * APIAstahf쐬TvR[h. 
 * pbP[W1Ɣz̃NX2ÅԂ̊֘A쐬B
 * ̃Tvł́A}͍쐬ȂB}Ōꍇ́A[NX}̎쐬]
 * c[}ւ̃hbOAhhbvłB
 */
public class APIForEditingModelsSample {

	//installer
	private static final String PROJECT_PATH = "./SampleModel.asta";
	//eclipse
	//private static final String PROJECT_PATH = "api_sample\\simpleEdit\\SampleModel.asta";
	
    public static void main(String[] args) {

        try {
            System.out.println("Creating new project...");

            // vWFNg쐬āAN_ƂȂ郂f擾
            ProjectAccessor prjAccessor = ProjectAccessorFactory.getProjectAccessor();
            prjAccessor.create(PROJECT_PATH);
            IModel project = prjAccessor.getProject();

            System.out.println("Creating new elements in the project...");

            // NXȂǂ̃fvf쐬܂͕ҏWꍇA܂Ƃ܂PʂƂăgUNV삪Kv
            TransactionManager.beginTransaction();

            // NX֘Ãfvf쐬GfB^擾
            BasicModelEditor basicModelEditor = ModelEditorFactory.getBasicModelEditor();

            // pbP[W쐬
            IPackage packageA = basicModelEditor.createPackage(project, "PackageA");

            // w̃pbP[WɃNX쐬
            IClass classA = basicModelEditor.createClass(packageA, "ClassA");
            // NX̒`ǉ
            classA.setDefinition("Definition of ClassA");
            // NXɑǉ
            basicModelEditor.createAttribute(classA, "attribute0", "int");
            // NXɑǉ
            basicModelEditor.createOperation(classA, "operation0", "void");

            // w̃pbP[WɃNX쐬
            IClass classB = basicModelEditor.createClass(packageA, "ClassB");

            // NXԂ̊֘A쐬
            basicModelEditor.createAssociation(classA, classB, "association name",
                    "classA end", "classB end");

            // gUNV̏I
            TransactionManager.endTransaction();

            // vWFNgۑ
            prjAccessor.save();

            // vWFNg
            prjAccessor.close();

            System.out.println("Finished");

        } catch (LicenseNotFoundException e) {
            e.printStackTrace();
        } catch (ProjectNotFoundException e) {
            e.printStackTrace();
        } catch (ProjectLockedException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (InvalidEditingException e) {
            // gUNV̕
            TransactionManager.abortTransaction();
            // sҏW̗ObZ[W擾
            System.err.println(e.getMessage());
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Throwable e) {
            e.printStackTrace();
        }
    }
}
