import java.io.IOException;

import com.change_vision.jude.api.inf.exception.LicenseNotFoundException;
import com.change_vision.jude.api.inf.exception.NonCompatibleException;
import com.change_vision.jude.api.inf.exception.ProjectLockedException;
import com.change_vision.jude.api.inf.exception.ProjectNotFoundException;
import com.change_vision.jude.api.inf.model.IAttribute;
import com.change_vision.jude.api.inf.model.IClass;
import com.change_vision.jude.api.inf.model.IModel;
import com.change_vision.jude.api.inf.model.INamedElement;
import com.change_vision.jude.api.inf.model.IOperation;
import com.change_vision.jude.api.inf.model.IPackage;
import com.change_vision.jude.api.inf.project.ProjectAccessor;
import com.change_vision.jude.api.inf.project.ProjectAccessorFactory;

/**
 * APIAstahf̃pbP[W񂨂уNX擾TvR[h. 
 * pbP[WNXȂǂR\[ɏo͂B
 */
public class APIForReadingModelsSample {
	
	//installer
	private static final String PROJECT_PATH = "./SampleModel.asta";
	//eclipse
	//private static final String PROJECT_PATH = "api_sample\\simpleRead\\SampleModel.asta";

    public static void main(String[] args) {
        try {
            System.out.println("Opening project...");

            ProjectAccessor prjAccessor = ProjectAccessorFactory.getProjectAccessor();

            // vWFNgJB
            // ԖڂtrueŃfo[W`FbNw肷B
            // ԖڂfalseŃvWFNgt@CbNȂB
            // OԖڂtrueŃvWFNgt@CbNĂꍇAǍݐp[hŃvWFNgJB
            prjAccessor.open(PROJECT_PATH, true, false, true);

            System.out.println("Printing the elements...");

            // N_ƂȂ郂f擾B
            IModel project = prjAccessor.getProject();

            // vWFNgɊ܂܂SẴpbP[WƃNX擾B
            printPackageInfo(project);

            // vWFNg
            prjAccessor.close();

            System.out.println("Finished");

        } catch (LicenseNotFoundException e) {
            e.printStackTrace();
        } catch (ProjectNotFoundException e) {
            e.printStackTrace();
        } catch (ProjectLockedException e) {
            e.printStackTrace();
        } catch (NonCompatibleException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Throwable e) {
            e.printStackTrace();
        }
    }

    private static void printPackageInfo(IPackage iPackage) {
        // pbP[W\
        System.out.println("Package name: " + iPackage.getName());
        // pbP[W̒`\
        System.out.println("Package definition: " + iPackage.getDefinition());

        // pbP[W̗vfiNXpbP[Wj\
        INamedElement[] iNamedElements = iPackage.getOwnedElements();
        for (int i = 0; i < iNamedElements.length; i++) {
            if (iNamedElements[i] instanceof IPackage) {
                IPackage iChildPackage = (IPackage) iNamedElements[i];
                // pbP[W\
                printPackageInfo(iChildPackage);
            } else if (iNamedElements[i] instanceof IClass) {
                IClass iClass = (IClass) iNamedElements[i];
                // NX\
                printClassInfo(iClass);
            }
        }
    }

    private static void printClassInfo(IClass iClass) {
        // NX\
        System.out.println("Class name: " + iClass.getName());
        // NX̒`\
        System.out.println("Class definition: " + iClass.getDefinition());

        // SĂ̑\
        IAttribute[] iAttributes = iClass.getAttributes();
        for (int i = 0; i < iAttributes.length; i++) {
            printAttributeInfo(iAttributes[i]);
        }

        // SĂ̑\
        IOperation[] iOperations = iClass.getOperations();
        for (int i = 0; i < iOperations.length; i++) {
            printOperationInfo(iOperations[i]);
        }

        // Ci[NX̏\
        IClass[] iClasses = iClass.getNestedClasses();
        for (int i = 0; i < iClasses.length; i++) {
            printClassInfo(iClasses[i]);
        }
    }

    private static void printOperationInfo(IOperation iOperation) {
        // 얼\
        System.out.println("Operation name: " + iOperation.getName());
        // ̕Ԃl̃^Cv\
        System.out.println("Operation returnType: " + iOperation.getReturnTypeExpression());
        // ̒`\
        System.out.println("Operation definition: " + iOperation.getDefinition());
    }

    private static void printAttributeInfo(IAttribute iAttribute) {
        // \
        System.out.println("Attribute name: " + iAttribute.getName());
        // ̃^Cv\
        System.out.println("Attribute type: " + iAttribute.getTypeExpression());
        // ̒`\
        System.out.println("Attribute definition: " + iAttribute.getDefinition());
    }
}
