#!/bin/sh

## Execution examples
# ---------------------------------------------------------------------------
# Batch file to run command line tool for ASTAH
# ---------------------------------------------------------------------------
# Command Examples
# ---------------------------------------------------------------------------
# call astah-command.bat -image er -f C:\input\hoge.asta -t png -o C:\output
# call astah-command.bat -image all -f C:\input\hoge.asta -t png -o C:\output
# ---------------------------------------------------------------------------
# Option Examples
# ---------------------------------------------------------------------------
# usage: Export Image Options
#  -f,--file <target file>    target file
#  -image                     export documents to image
#  -o,--output <output dir>   output dir
#  -t,--type <image type>     png/jpg/emf
# ---------------------------------------------------------------------------

#export JAVA_HOME=/usr/lib/j2sdk1.4
#export PATH=$PATH:$JAVA_HOME/bin

#ASTAH_HOME=/usr/local/astah_professional
ASTAH_HOME=`pwd`

INITIAL_HEAP_SIZE=64m
MAXIMUM_HEAP_SIZE=1024m
STACK_SIZE=3m

JAVA_OPTS="-Xms$INITIAL_HEAP_SIZE -Xmx$MAXIMUM_HEAP_SIZE -Xss$STACK_SIZE"

java $JAVA_OPTS -cp $ASTAH_HOME/astah-uml.jar com.change_vision.jude.cmdline.JudeCommandRunner %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
